* Foxcol26.prg
* Popups R Us programs

PROCEDURE base2
** fill up the array for the array popups
SELECT st_code+CHR(179)+st_name FROM bkstates ;
  ORDER BY st_code INTO ARRAY goodst
** Since the bkstates database must be open 
** after the preceding SQL-SELECT command,
** set the right order for the database popups
SET ORDER TO st_code IN bkstates
SET TALK OFF
DEFINE WINDOW base FROM 2,5 TO 20,50 ;
  TITLE "Base 2" SHADOW FLOAT
ACTIVATE WINDOW base
@ 2,0 SAY "Company "
@ 4,0 SAY "State"
@ 2,8 GET company ;
  DEFAULT SPACE(30)

** Popup triggered when user exits with an
** invalid state field value
@ 4,8 GET state PICTURE "!!" ;
  DEFAULT SPACE(2) ;
  VALID pop01(@m.state) && pass m.state BY reference

** Popup triggered when user attempts to enter
** the state1 GET.
@ 5,8 GET state1 PICTURE "!!" ;
  DEFAULT SPACE(2) ;
  WHEN pop02(@m.state1)

** Popup triggered when user attempts to enter
** the state2 GET.
@ 6,8 GET state2 PICTURE "!!" ;
  DEFAULT SPACE(2) ;
  WHEN pop03(@m.state2)

** Invisible button popup "behind" a WHEN .F. GET
state3="  "  && code variable
state4=SPACE(20)  && full name variable
invstate=0  && invisible button for state
@ 7,8 GET state4 WHEN .F. 
@ 7,8 GET invstate PICTURE "@*I" SIZE 1,20 ;
  VALID pop04(@m.state3,@m.state4)

READ CYCLE
RELEASE WINDOW base
* EOP base2

PROCEDURE pop01
* first popup using DEFINE POPUP
PARAMETERS thisstate
* Make all variable that start with l_
* private to this procedure
PRIVATE ALL LIKE l_*
l_bkstates=.T.
* Since the valid states are stored in the
* bkstates database, make sure bkstates is open
IF !USED('bkstates')
  USE bkstates IN SELECT(1) AGAIN
  * flag to show that bkstates was not open
  l_bkstates=.F.
ENDIF bkstates not already open
* save old bkstates order
l_oldord=ORDER('bkstates')
* if necessary, set order in bkstates
IF l_oldord#"ST_CODE"
  SET ORDER TO st_code IN bkstates
ENDIF
* Save current record pointer in bkstates
l_bkstrec=RECNO('bkstates')
* Save current setting of SET NEAR
l_oldnear=SET('near')
SET NEAR ON
* see if the user gave us a valid value to begin with
IF !SEEK(thisstate,'bkstates') && invalid state code
  * create the popup
  DEFINE POPUP pop01 FROM 3,8 TO 9,40 ;
    TITLE "Pick a State" ;
    FOOTER "{Enter} to select" ;
    SHADOW SCROLL  ;
    PROMPT FIELD bkstates.st_code+;
    CHR(179)+bkstates.st_name
  * now tell FoxPro what to do when the user
  * chooses a state
  ON SELECTION POPUP pop01 DEACTIVATE POPUP pop01
  * Now enable the user to type characters and
  * get closer to the desired state
  l_oldconf=SET('CONFIRM')
  SET CONFIRM ON
  * Finally, start the popup at the current spot
  * in the bkstates database
  ACTIVATE POPUP pop01 REST
  * Since the user must be positioned on a valid
  * state record, put the st_code value into our
  * memory variable
  thisstate = bkstates.st_code
  * clean up
  RELEASE POPUP pop01
  IF l_oldconf#"ON"
    SET CONFIRM OFF
  ENDIF need to reset confirm
ENDIF entered an invalid value
* close bkstates if it wasn't open when we
* started this call to pop01
IF !l_bkstates
  USE IN bkstates
ELSE && bkstates was OPEN prior TO pop01
  * reset the order in bkstates if necessary
  IF l_oldord#"ST_CODE"
    SET ORDER TO (l_oldord) IN bkstates
  ENDIF need to reset the order
  * go back to original record in bkstates
  GOTO l_bkstrec IN bkstates
ENDIF && bkstates was NOT OPEN prior TO pop01
* reset SET NEAR if necessary
IF l_oldnear#"ON"
  SET NEAR OFF
ENDIF
* Since the user either entered a valid value to
* begin with, or subsequently was forced to choose
* a valid value, we can always return true
RETURN .T.

PROCEDURE pop02
* second popup using old-fashioned @ menu code
PARAMETERS thisstate
* Make all variable that start with l_
* private to this procedure
PRIVATE ALL LIKE l_*
* create the popup
@ 2,8 MENU goodst,ALEN(goodst),3 TITLE "Choose State" SHADOW 
* find out which element the state is currently on
l_state=ASCAN(goodst,thisstate)
* Now enable the user to type characters and
* get closer to the desired state
l_oldconf=SET('CONFIRM')
SET CONFIRM ON
l_first=.T. && set the flag so the loop is entered
* setup a loop to get the user's selection
* stay in the loop until the user chooses
* a valid value.
DO WHILE l_state=0.OR.l_first
  l_first=.F.
  ** read the popup
  READ MENU TO l_state
  * if the user presses escape, l_state will = 0
ENDDO
* Since the user must be positioned on a valid
* state array element, put the st_code value into our
* memory variable
thisstate = LEFT(goodst(l_state),2)
* clean up
IF l_oldconf#"ON"
  SET CONFIRM OFF
ENDIF need to reset confirm
* Since When clauses that return .F. do not
* automatically refresh gets, refresh the
* associated GET
SHOW GET state1
* Since the user either entered a valid value to
* begin with, or subsequently was forced to choose
* a valid value, we can always return false, forcing
* the system to skip on to the next field.
RETURN .F.

PROCEDURE pop03
* third popup using a scrollable list
PARAMETERS thisstate
PRIVATE ALL LIKE l_*
* create a window for the scrollable list
DEFINE WINDOW pop03 IN WINDOW BASE ;
  FROM 2,8 TO 10,22 NONE SHADOW
* find out which element the state is currently on
l_state=ASCAN(goodst,thisstate)
* create the scrollable list
ACTIVATE WINDOW pop03 
@ 0,0 GET l_state FROM goodst SIZE 11,20 ;
  VALID pop03a(l_state)
* start a MODAL READ session to process
* the scrollable list.
READ CYCLE VALID l_state>0 DEACTIVATE pop03a(l_state)
thisstate = LEFT(goodst(l_state),2)
* clean up
RELEASE WINDOW pop03
SHOW GET state2
RETURN .F.

PROCEDURE pop03a
* validates the scrollable list for the 
* pop03 popup
PARAMETERS thisval
IF thisval>0
  CLEAR READ
  RETURN .T.
ELSE
  ?? CHR(7)
  _curobj=objnum(l_state)
  ACTIVATE WINDOW pop03
  RETURN .F.
ENDIF

PROCEDURE pop04
* BROWSE lookup into state database
PARAMETERS thiscode,thisname
PRIVATE ALL LIKE l_*
l_oldnear=SET('NEAR')
SET NEAR ON
l_oldselect=SELECT()
SELECT bkstates
** put them on the current state code, or close
** if the state code is invalid
SEEK thiscode
** Prevent any predefined OKLs from messing up
** the BROWSE popup.
PUSH KEY CLEAR
** Setup both the enter key and the right mouse
** button to exit the BROWSE popup.
ON KEY LABEL ENTER KEYBOARD "{Ctrl+w}" PLAIN
ON KEY LABEL RIGHTMOUSE KEYBOARD "{Ctrl+w}" PLAIN
** Make a window
DEFINE WINDOW pop04 IN WINDOW base ;
  FROM 2,8 TO 15,35 FLOAT 
** Make a read only BROWSE WINDOW  
BROWSE FIELDS st_code:h="ST",st_name:h="NAME":20 ;
  WHEN .F. WINDOW pop04 NOMENU NOAPPEND NODELETE NOMODIFY
** Reset enter and rightmouse keys
ON KEY LABEL ENTER
ON KEY LABEL RIGHTMOUSE
** assign values from newly 
thiscode=bkstates.st_code
thisname=bkstates.st_name
** Display new value in m.state4
SHOW GET m.state4 
** Clean up
SELECT (l_oldselect)
IF l_oldnear#"ON"
  SET NEAR OFF
ENDIF
POP KEY
RETURN .T.

